#ifndef LISTENTHREAD_H_INCLUDED
#define LISTENTHREAD_H_INCLUDED

#include "wx/thread.h"
#if defined(__UNIX__)
#include "AvahiMulticast.h"
#endif
#if defined(__WXMSW__)
#include "BonjourMultiBrowse.h"
#endif

class ListenThread : public wxThread
{
public:
    ListenThread();
    virtual void *Entry();
    void ExcuteFree();
    void OnExit();
    static bool m_bExcuting;

private:
    #if defined(__UNIX__)
        AvahiMulticast multicast;
    #endif
    #if defined(__WXMSW__)
        BonjourMultiBrowse multicast;
    #endif
};

#endif // LISTENTHREAD_H_INCLUDED
