#ifndef MESHCONFIGURATIONDLG_H
#define MESHCONFIGURATIONDLG_H

//(*Headers(MeshConfigurationDlg)
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/panel.h>
#include <wx/statbmp.h>
#include <wx/button.h>
#include <wx/dialog.h>
//*)
#include "MeshConfigurationEntity.h"
#include "XMLOperator.h"

class MeshConfigurationDlg: public wxDialog
{
	public:

		MeshConfigurationDlg(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~MeshConfigurationDlg();

		//(*Declarations(MeshConfigurationDlg)
		wxStaticText* StaticText2;
		wxStaticText* StaticText6;
		wxStaticBitmap* StaticBitmap1;
		wxButton* ButtonOK;
		wxPanel* Panel1;
		wxStaticText* StaticText1;
		wxTextCtrl* TextCtrlMeshChannel;
		wxStaticText* StaticText3;
		wxTextCtrl* TextCtrlLocalHostName;
		wxButton* ButtonCancel;
		wxStaticText* StaticText5;
		wxStaticText* StaticText7;
		wxStaticText* StaticText4;
		wxTextCtrl* TextCtrlAdvertisementTime;
		//*)
		MeshConfigurationEntity meshConfigurationEntity;
        XMLOperator xmlOperator;
	protected:

		//(*Identifiers(MeshConfigurationDlg)
		static const long ID_STATICTEXT1;
		static const long ID_STATICTEXT2;
		static const long ID_STATICTEXT3;
		static const long ID_STATICTEXT4;
		static const long ID_STATICTEXT5;
		static const long ID_STATICTEXT6;
		static const long ID_STATICTEXT7;
		static const long ID_TEXTCTRL_LOCAL_HOST_NAME;
		static const long ID_TEXTCTRL_MESH_CHANNEL;
		static const long ID_TEXTCTRL_ADVERTISEMENT_TIME;
		static const long ID_BUTTON_OK;
		static const long ID_BUTTON_CANCEL;
		static const long ID_STATICBITMAP1;
		static const long ID_PANEL1;
		//*)

	private:

		//(*Handlers(MeshConfigurationDlg)
		void OnButtonOKClick(wxCommandEvent& event);
		void OnButtonCancelClick(wxCommandEvent& event);
		void OnInit(wxInitDialogEvent& event);
		//*)
        bool CheckMeshSettings();
		DECLARE_EVENT_TABLE()
};

#endif
