//#include "dns_sd.h"
#include "StopPublishThread.h"
#include "ENMApp.h"

StopPublishThread::StopPublishThread():wxThread(wxTHREAD_DETACHED)
{
}

void *StopPublishThread::Entry()
{
    #if defined(__WXMSW__)
    if (wxGetApp().m_serviceclient)
    {
        DNSServiceRefDeallocate(wxGetApp().m_serviceclient);
        wxGetApp().m_serviceclient = NULL;
    }
    #endif
    #if defined(__UNIX__)
    if (wxGetApp().group)
    {
        avahi_entry_group_free (wxGetApp().group);
        wxGetApp().group = NULL;
    }
    if (wxGetApp().client)
    {
        avahi_client_free(wxGetApp().client);
        wxGetApp().client = NULL;
    }
    if (wxGetApp().simple_poll)
    {
        avahi_simple_poll_free(wxGetApp().simple_poll);
        wxGetApp().simple_poll = NULL;
    }
    if (wxGetApp().name)
    {
        avahi_free(wxGetApp().name);
        wxGetApp().name = NULL;
    }
    #endif

    return NULL;
}
