#ifndef TASKBARBALLOON_H_INCLUDED
#define TASKBARBALLOON_H_INCLUDED

#include <wx/event.h>
#include <wx/timer.h>
#include <wx/frame.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/dcprint.h>
#include <wx/dcclient.h>
#include <wx/image.h>
#include <wx/statbmp.h>
#include <wx/gbsizer.h>
#include <wx/bmpbuttn.h>
#include "BitmapDialog.h"

class TaskBarBalloon : public wxBitmapDialog
{
    public:
        TaskBarBalloon(wxBitmapDialog *dlg, const wxString& title);
        virtual ~TaskBarBalloon() { }

        /** painting bg */
        void OnPaint(wxPaintEvent& event);
        /** click on the balloon */
        void OnClick(wxMouseEvent & event);

        /** display the balloon and run the timer */
        void showBalloon();

        void SetConnectionTip(wxString wxsSuccTip);

        void SetConnectionType(wxString wxsType);

        void SetConnectionSpeed(wxString wxsSpeed);

        void SetConnectionStatus(wxString wxsStatus);

        void SetSignalQuality(int iSignalQuality);

        void SetSignalQualityBmp(int iSignalQuality);

//        void OnButtonClick(wxCommandEvent& event);

        wxStaticText* m_SignalQuality;
		wxStaticText* m_TypeTip;
		wxStaticText* m_StatusTip;
		wxStaticBitmap* m_bmpSignalQuality;
		wxStaticText* m_SignalQualityTip;
		wxStaticText* m_SuccTip;
		wxStaticText* m_Type;
		wxStaticText* m_Speed;
		wxStaticText* m_Status;
		wxStaticText* m_SpeedTip;
//		wxBitmapButton* m_btnClose;

    protected:
		static const long ID_STATICTEXT_SUCCTIP;
		static const long ID_STATICTEXT_TYPETIP;
		static const long ID_STATICTEXT_TYPE;
		static const long ID_STATICTEXT_SPEEDTIP;
		static const long ID_STATICTEXT_SPEED;
		static const long ID_STATICTEXT_STATUSTIP;
		static const long ID_STATICTEXT_STATUS;
		static const long ID_STATICTEXT_SIGNALQUALITYTIP;
		static const long ID_STATICBITMAP_SIGNALQUALITY;
		static const long ID_STATICTEXT_SIGNALQUALITY;
//		static const long ID_BTN_CLOSE;

        DECLARE_EVENT_TABLE();

};

#endif // TASKBARBALLOON_H_INCLUDED
